(** Tags and set of tags *)

module Symbol : sig
  type t = string
  val compare: t -> t -> int
end

module SymbolSet : sig
  type t

  val equal: t -> t -> bool
  val hash: t -> int
  val compare: t -> t -> int

  val print: Format.formatter -> t -> unit

  val any: t
  val empty: t
  val finite: Symbol.t list -> t
  val cofinite: Symbol.t list -> t

  val is_empty: t -> bool
  val has: t -> Symbol.t -> bool

  val inter: t -> t -> t
  val diff: t -> t -> t

  val subset: t -> t -> bool
  val disjoint: t -> t -> bool

  val sample: t -> Symbol.t

  val is_singleton: t -> bool
  val is_any: t -> bool
end
